﻿using Infragistics.Win;
using Infragistics.Win.UltraWinListView;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;

namespace CAS_144728_Y9M8R0
{
    public class MyCreationFilter : IUIElementCreationFilter
    {
        private static readonly Size CHECKBOX_SIZE = new Size(13, 13);
        private static readonly Size CHECKBOX_PADDING = new Size(15, 3);
        private CheckBoxStyle checkBoxStyle = CheckBoxStyle.CheckBox;


        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if ( this.checkBoxStyle == CheckBoxStyle.None )
                return;

            UltraListViewIconicImageAreaUIElement imageAreaElement = parent as UltraListViewIconicImageAreaUIElement;

            if ( imageAreaElement != null )
            {
                Rectangle imageAreaRect = imageAreaElement.RectInsideBorders;

                UltraListViewItem item = imageAreaElement.GetContext( typeof(UltraListViewItem) ) as UltraListViewItem;

                CheckBoxUIElement checkBoxElement = new ListViewCheckBoxUIElement( imageAreaElement );
                checkBoxElement.InitializeState( this.checkBoxStyle == CheckBoxStyle.TriState, item.CheckState );

                Rectangle checkBoxRect = imageAreaRect;
                checkBoxRect.Y = imageAreaRect.Top  + CHECKBOX_PADDING.Height;
                checkBoxRect.X = imageAreaRect.Right - CHECKBOX_PADDING.Width;
                checkBoxRect.Size = CHECKBOX_SIZE;
                checkBoxElement.Rect = checkBoxRect;

                parent.ChildElements.Add( checkBoxElement );
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
           return false;
        }


        public class ListViewCheckBoxUIElement : CheckBoxUIElement
        {
            public ListViewCheckBoxUIElement( UltraListViewIconicImageAreaUIElement parent ) : base( parent ){}

            protected override void  OnCheckStateChange()
            {
                UltraListViewItem item = this.GetContext( typeof(UltraListViewItem) ) as UltraListViewItem;
                item.CheckState = this.CheckState;

              base.OnCheckStateChange();
            }

        }
    }
}
